/* Copyright (c) 2016 AO MCST. All rights reserved.
 * Distributed under the terms of MIT License.
 */

#include <errno.h>
#include "f2c.h"

/* общие константы и таблица */
extern DB consterfc[];

#define KB5 8.33333478792298551112e-03
#define KB4 4.16666768487944911020e-02
#define KB3 1.66666666666665333693e-01
#define KB2 4.99999999999990669185e-01
#define KA1_hi 1.128378868103027344

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                        %
%     ПРОГРАММА  ВЫЧИСЛЯEТ  ЗНАЧEНИE  ФУНКЦИИ  ОШИБОК.   %
%                                                        %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

DB __erf (DB X)

#define KA19 -1.41912208093140066736e-07
#define KA17 1.63195299485624537597e-06
#define KA15 -1.49204080546172495895e-05
#define KA13 1.20552159051735341781e-04
#define KA11 -8.54832540096177415019e-04
#define KA9 5.22397761173287325478e-03
#define KA7 -2.68661706444652504762e-02
#define KA5 1.12837916709534815210e-01
#define KA3 -3.76126389031837367089e-01
#define KA1_lo 2.98992485229896954016e-07
{
    _type_double_bits arg, rez, hi_pol;
    DB y, yv2, yv4, hi, *A0, ed = 1.0;
    LL k, ind;

    arg.value = dfabs (X);
    if (arg.llong >= 0x4017afb500000000LL) { /* |X| >= 5.921589 */
        return (arg.llong > 0x7ff0000000000000LL) ? X + X /* NaN */
            : (X > 0) ? ed - DB_MIN : DB_MIN - ed;
    }
    rez.value = X;
    rez.llong &= ~0xffffffffLL;
    hi = X - rez.value;
    if (arg.llong < 0x3fdf000000000000LL) {        /* |X| < 0.484375 */
        if (arg.llong == 0) return X;
        y = X * X;
        yv2 = y * y;
        yv4 = yv2 * yv2;
        return KA1_lo * rez.value + (KA1_hi + KA1_lo) * hi + KA7 * X
            * (y + KA5 / KA7) * yv2 + KA15 * X * yv4 * (KA9 / KA15 + KA11 / KA15 * y
            + yv2 * (y + KA13 / KA15)) + KA19 * X * (y + KA17 / KA19) * yv4 *
            yv4 + KA3 * (X * y) + rez.value * KA1_hi;
    }
    hi_pol.llong = (arg.llong + 0x1000000000000LL) & 0x7ffe000000000000LL;
    A0 = consterfc + ((hi_pol.llong - 0x3fe0000000000000LL) >> 49) * 9;
    y = arg.value - hi_pol.value;
    yv2 = y * y;
    yv4 = (A0[2] * y + yv2 * (A0[3] + A0[4] * y)) / (A0[5] + A0[6]
          * y + A0[7] * yv2 + yv2 * (A0[8] * y + yv2)) + A0[1];

    y = rez.value * rez.value;
    yv2 = hi * (X + rez.value);
    hi = -K256ONLN2 * y;
    k = (int) hi;
#if __iset__ <= 2
    hi = (DB) k;
#else /*  __iset__ <= 2 */
#pragma asm_inline
   __asm ("fdtoifd 0x3,%1,%0" : "=r" (hi): "r" (hi));
#endif /*  __iset__ <= 2 */
    y = -KLN2ON256_hi * hi - y - (hi * KLN2ON256_lo + yv2);
    yv2 = y * y;
    y = KB2 * y * (y + 1 / KB2) + KB3 * y * yv2 + yv2 * yv2 * (KB5 * y + KB4);
    rez.value = hi = constexp[ind = k & 255];
    rez.llong &= ~0xffffffffLL;
    hi_pol.value = hi * y + (constexp_lo[ind] + (hi - rez.value));
    k = ((k >> 8) + 110) << 52;
    hi_pol.llong += k;
    rez.llong += k;
    yv2 = A0[0];
    y = hi_pol.value * (yv2 + yv4) + rez.value * yv4;
    yv2 *= rez.value;
    if (arg.llong < 0x4001000000000000LL)  /* |X| < 2.125 */
        ed -= yv2;
    else
        y += yv2;
    return (X < 0) ? y - ed : ed - y;
}
weak_alias (__erf, erf)
#ifdef NO_LONG_DOUBLE
strong_alias (__erf, __erfl)
weak_alias (__erf, erfl)
#endif

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                        %
%     ПРОГРАММА  ВЫЧИСЛЯЕТ  ЗНАЧЕНИЕ  ДОПОЛНИТЕЛЬНОЙ     %
%  ФУНКЦИИ  ОШИБОК.                                      %
%                                                        %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

#undef KA17
#undef KA15
#undef KA13
#undef KA11
#undef KA9
#undef KA7
#undef KA5
#undef KA3
#undef KA1_lo
#define KA17 1.48268600162859600881e-06
#define KA15 -1.48550292377337917220e-05
#define KA13 1.20536727325036905705e-04
#define KA11 -8.54830418843711767296e-04
#define KA9 5.22397744059043201737e-03
#define KA7 -2.68661706367157328353e-02
#define KA5 1.12837916709359187867e-01
#define KA3 -3.76126389031835835894e-01
#define KA1_lo 2.98992485227700740102e-07
#define KG3 (-3.14081826066942930906e+01*K2IN110)
#define KG2 (-2.46487445774893173024e+01*K2IN110)
#define KG1 (-5.01080391035959826098e+00*K2IN110)
#define KG0 (-2.82094791773864884724e-01*K2IN110)
#define KH5 -9.85062817707859383015e+00
#define KH4 1.03322545908862485144e+02
#define KH3 2.21011136954977301945e+02
#define KH2 1.12521780564470239729e+02
#define KH1 1.92628373740676880523e+01
#define KH0 (5.64189583547756277235e-01*K2IN110)

DB __erfc (DB X)
{
    _type_double_bits arg, rez, hi_pol;
    DB y, yv2, yv4, hi, two = 2.0, *A0;
    LL k, ind;

    arg.value = dfabs (X);
    hi_pol.value = 0;
    if (arg.llong >= 0x7ff0000000000000LL) {       /* |X| = NaN или Inf */
        return (X != X) ? X + X /* NaN */ : (X > 0) ? 0 : two; /* Inf */
    }
    if (arg.llong >= 0x403b39dd00000000LL) { /* |X| >= 27.226017 */
        if (X > 0) __set_errno (ERANGE);
#if ! defined __LCC__
        return (X > 0) ? DB_MIN * DB_MIN : two - DB_MIN;
#else /* defined __LCC__  */
	{
	  /* Suppress "floating point operation result is out of range" EDG
	     warning this way.  */
	  DB db_min = DB_MIN;
	  return (X > 0) ? db_min * db_min : two - db_min;
	}
#endif /* defined __LCC__  */
    }
    rez.value = X;
    rez.llong &= ~0xffffffffLL;
    hi = X - rez.value;
    y = X * X;
    yv2 = y * y;
    yv4 = yv2 * yv2;
    if (arg.llong < 0x3fdf000000000000LL) {        /* |X| < 0.484375 */
        yv2 = KA1_lo * rez.value + (KA1_hi + KA1_lo) * hi + KA7 * X
            * (y + KA5 / KA7) * yv2 + KA15 * X * yv4 * (KA9 / KA15 + KA11 / KA15 * y
            + yv2 * (y + KA13 / KA15)) + KA17 * X * yv4 * yv4;
        y = KA3 * (X * y);
        hi = rez.value * KA1_hi;
        return (arg.llong < 0x3f50000000000000LL) ?        /* |X| < 2^-10 */
            1.0 - (y + hi + yv2) : 1.0 - hi - (y + yv2);
    }
    if (arg.llong < 0x4019000000000000LL) {        /* |X| < 6.25 */
        hi_pol.llong = (arg.llong + 0x1000000000000LL) & 0x7ffe000000000000LL;
        A0 = consterfc + ((hi_pol.llong - 0x3fe0000000000000LL) >> 49) * 9;
        y = arg.value - hi_pol.value;
        yv2 = y * y;
        yv4 = (A0[2] * y + yv2 * (A0[3] + A0[4] * y)) / (A0[5] + A0[6]
              * y + A0[7] * yv2 + yv2 * (A0[8] * y + yv2)) + A0[1];
        yv2 = A0[0];
    }
    else {
        yv4 = (KG2 * arg.value * (KG3 / KG2 + y) + KG0 * arg.value * (KG1 / KG0 + y) * yv2)
            / (KH5 + KH4 * y + yv2 * (KH3 + KH2 * y) + yv4 * (KH1 + y));
        hi_pol.value = KH0 / X;
        hi_pol.llong &= ~0xffffffffLL;
        yv4 += (KH0 - hi_pol.value * rez.value - hi_pol.value * hi) / arg.value;
        yv2 = dfabs (hi_pol.value);
    }
    y = rez.value * rez.value;
    arg.value = hi * (X + rez.value);
    k = (int) (-K256ONLN2 * y);
    hi = (DB) k;
    y = -KLN2ON256_hi * hi - y - (hi * KLN2ON256_lo + arg.value);
    hi = y * y;
    y = KB2 * y * (y + 1 / KB2) + KB3 * y * hi + hi * hi * (KB5 * y + KB4);
    arg.value = hi = constexp[ind = k & 255];
    arg.llong &= ~0xffffffffLL;
    hi_pol.value = hi * y + (constexp_lo[ind] + (hi - arg.value));
    k = ((k >> 8) + 110) << 52;
    hi_pol.llong += k;
    arg.llong += k;
    y = hi_pol.value * (yv2 + yv4) + arg.value * yv4;
    hi = yv2 * arg.value;
    if (X > 0)
        return y + hi;
    else
        return (rez.value >= -two) ? two - hi - y : two - (y + hi);
}
weak_alias (__erfc, erfc)
#ifdef NO_LONG_DOUBLE
strong_alias (__erfc, __erfcl)
weak_alias (__erfc, erfcl)
#endif

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*         КОНСТАНТЫ  ФУНКЦИЙ  ERF И ERFC               */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

DB consterfc[] = {
    4.7431059302435063960e-34,  /* A0_hi = exp(0.5^2)*erfc(0.5) */
   -4.8838547071820379428e-42,  /* A0_lo */
   -1.2610558266780216511e-30,  /* P0  */
   -7.1353754210434046135e-31,  /* P1  */
   -1.4119746742834659034e-31,  /* P2  */
    3.1928608128353134816e+03,  /* Q0  */
    4.0444927582812892979e+03,  /* Q1  */
    1.8096902460836633963e+03,  /* Q2  */
    2.9031887654226625273e+02,  /* Q3  */
    4.5066653434801806428e-34,  /* A0_hi = exp(0.5625^2)*erfc(0.5625) */
    1.0661538126811674543e-41,  /* A0_lo */
   -1.3542685457022343453e-30,  /* P0  */
   -7.6410603008177726511e-31,  /* P1  */
   -1.4827140307755236270e-31,  /* P2  */
    3.7382662492243230190e+03,  /* Q0  */
    4.6568388155851007468e+03,  /* Q1  */
    2.0461075506828581183e+03,  /* Q2  */
    3.2156749244938566790e+02,  /* Q3  */
    4.2895382207363612313e-34,  /* A0_hi = exp(0.625^2)*erfc(0.625) */
   -1.1423845715782659784e-41,  /* A0_lo */
   -1.4806885501540285814e-30,  /* P0  */
   -8.3410166634619450962e-31,  /* P1  */
   -1.5891556430753781497e-31,  /* P2  */
    4.4454518315775094379e+03,  /* Q0  */
    5.4508464855649081073e+03,  /* Q1  */
    2.3542919141198690340e+03,  /* Q2  */
    3.6292276347607213438e+02,  /* Q3  */
    4.0896803038675712773e-34,  /* A0_hi = exp(0.6875^2)*erfc(0.6875) */
    1.3530020499887692411e-41,  /* A0_lo */
   -1.6212512855680548091e-30,  /* P0  */
   -9.1135698464040415595e-31,  /* P1  */
   -1.7058583520009455133e-31,  /* P2  */
    5.2819702766879681803e+03,  /* Q0  */
    6.3755123472814693741e+03,  /* Q1  */
    2.7072664099455669202e+03,  /* Q2  */
    4.0944966792143912926e+02,  /* Q3  */
    3.9053053924735378515e-34,  /* A0_hi = exp(0.75^2)*erfc(0.75) */
    2.1007395171993341667e-41,  /* A0_lo */
   -1.7774722965734628555e-30,  /* P0  */
   -9.9657838362459646061e-31,  /* P1  */
   -1.8336304521152838999e-31,  /* P2  */
    6.2702776801872778378e+03,  /* Q0  */
    7.4511081450929905259e+03,  /* Q1  */
    3.1111131897366176418e+03,  /* Q2  */
    4.6174513003483616558e+02,  /* Q3  */
    3.7348467729898056240e-34,  /* A0_hi = exp(0.8125^2)*erfc(0.8125) */
   -4.6297617875059404586e-43,  /* A0_lo */
   -1.9510262692897766669e-30,  /* P0  */
   -1.0905372278306421800e-30,  /* P1  */
   -1.9733467342244260565e-31,  /* P2  */
    7.4364729031518199918e+03,  /* Q0  */
    8.7008117633857527835e+03,  /* Q1  */
    3.5726660275864905998e+03,  /* Q2  */
    5.2046741976925181916e+02,  /* Q3  */
    3.5769262242077835416e-34,  /* A0_hi = exp(0.875^2)*erfc(0.875) */
    1.0225567943216112552e-41,  /* A0_lo */
   -2.1437619281122411401e-30,  /* P0  */
   -1.1940749699959185334e-30,  /* P1  */
   -2.1259519923713831336e-31,  /* P2  */
    8.8108404832874875865e+03,  /* Q0  */
    1.0151083964096043928e+04,  /* Q1  */
    4.0995924251121577981e+03,  /* Q2  */
    5.8634153703827894333e+02,  /* Q3  */
    3.4303299104570033555e-34,  /* A0_hi = exp(0.9375^2)*erfc(0.9375) */
   -5.6300457369530655877e-42,  /* A0_lo */
   -2.3577181942403533724e-30,  /* P0  */
   -1.3081086174372913584e-30,  /* P1  */
   -2.2924647684803166035e-31,  /* P2  */
    1.0428466426091998073e+04,  /* Q0  */
    1.1832088108082436520e+04,  /* Q1  */
    4.7004833369564312306e+03,  /* Q2  */
    6.6016497440224543425e+02,  /* Q3  */
    3.2939840451986377535e-34,  /* A0_hi = exp(1.0^2)*erfc(1.0) */
    6.9879574870683677491e-43,  /* A0_lo */
   -2.6734727894863868293e-30,  /* P0  */
   -1.4806330584479687231e-30,  /* P1  */
   -2.5589393135150435098e-31,  /* P2  */
    1.2702099116329380195e+04,  /* Q0  */
    1.4211726636053090260e+04,  /* Q1  */
    5.5623722609316682792e+03,  /* Q2  */
    7.6851340799402873927e+02,  /* Q3  */
    3.0483470518500507604e-34,  /* A0_hi = exp(1.125^2)*erfc(1.125) */
    6.9540498938858193725e-42,  /* A0_lo */
   -3.1478019884810782953e-30,  /* P0  */
   -1.7219399259358168188e-30,  /* P1  */
   -2.8837944988249663280e-31,  /* P2  */
    1.7164187786833917926e+04,  /* Q0  */
    1.8609717840371846250e+04,  /* Q1  */
    7.0418995548100538144e+03,  /* Q2  */
    9.3753323144678472545e+02,  /* Q3  */
    2.8336046673527139857e-34,  /* A0_hi = exp(1.25^2)*erfc(1.25) */
    8.7570728110408088513e-43,  /* A0_lo */
   -3.8296004387775816629e-30,  /* P0  */
   -2.0719289653604759685e-30,  /* P1  */
   -3.3715674328253055645e-31,  /* P2  */
    2.3805482825801205763e+04,  /* Q0  */
    2.5054069088564585400e+04,  /* Q1  */
    9.1841327631091662624e+03,  /* Q2  */
    1.1811202418027683052e+03,  /* Q3  */
    2.6446554298950510177e-34,  /* A0_hi = exp(1.375^2)*erfc(1.375) */
   -9.3612931908249532295e-42,  /* A0_lo */
   -4.6657895077866034441e-30,  /* P0  */
   -2.4937520938188348939e-30,  /* P1  */
   -3.9466201991369927005e-31,  /* P2  */
    3.2859645757345781021e+04,  /* Q0  */
    3.3583250919032157981e+04,  /* Q1  */
    1.1931913474788687381e+04,  /* Q2  */
    1.4833205133519024912e+03,  /* Q3  */
    2.4774039355258962383e-34,  /* A0_hi = exp(1.5^2)*erfc(1.5) */
   -2.6154570825442349721e-43,  /* A0_lo */
   -5.6894951772933836780e-30,  /* P0  */
   -3.0010049647527928124e-30,  /* P1  */
   -4.6226757260501179667e-31,  /* P2  */
    4.5136629307629809773e+04,  /* Q0  */
    4.4814800528528685390e+04,  /* Q1  */
    1.5440142781719321647e+04,  /* Q2  */
    1.8567023501495746132e+03,  /* Q3  */
    2.3285356116001673496e-34,  /* A0_hi = exp(1.625^2)*erfc(1.625) */
    4.4959180993584783687e-42,  /* A0_lo */
   -6.9403791408097486468e-30,  /* P0  */
   -3.6095727668656769065e-30,  /* P1  */
   -5.4153394674256741371e-31,  /* P2  */
    6.1693573935543950938e+04,  /* Q0  */
    5.9530382863162034482e+04,  /* Q1  */
    1.9898651207566901576e+04,  /* Q2  */
    2.3161513797669954329e+03,  /* Q3  */
    2.1953461323447519056e-34,  /* A0_hi = exp(1.75^2)*erfc(1.75) */
    1.0845435683919242810e-41,  /* A0_lo */
   -8.4657690384573210412e-30,  /* P0  */
   -4.3379529119195824058e-30,  /* P1  */
   -6.3422941903546898486e-31,  /* P2  */
    8.3902146244036848657e+04,  /* Q0  */
    7.8714007673874031752e+04,  /* Q1  */
    2.5538919049361767975e+04,  /* Q2  */
    2.8792207952593589653e+03,  /* Q3  */
    2.0756130787526265187e-34,  /* A0_hi = exp(1.875^2)*erfc(1.875) */
    2.6625163657481530587e-42,  /* A0_lo */
   -1.0321952254262331513e-29,  /* P0  */
   -5.2076130038728975876e-30,  /* P1  */
   -7.4235090645178245443e-31,  /* P2  */
    1.1353187714608082024e+05,  /* Q0  */
    1.0359779723632022797e+05,  /* Q1  */
    3.2641848455045881565e+04,  /* Q2  */
    3.5665216334749857197e+03,  /* Q3  */
    1.9674967562470062302e-34,  /* A0_hi = exp(2.0^2)*erfc(2.0) */
   -3.3553274964303619656e-42,  /* A0_lo */
   -1.3231446048996702053e-29,  /* P0  */
   -6.5872281153589430525e-30,  /* P1  */
   -9.1813111137272749559e-31,  /* P2  */
    1.6082367000212048879e+05,  /* Q0  */
    1.4301581519901729189e+05,  /* Q1  */
    4.3857450662329923944e+04,  /* Q2  */
    4.6560155356179529917e+03,  /* Q3  */
    1.7802314374057702286e-34,  /* A0_hi = exp(2.25^2)*erfc(2.25) */
    4.8015119359321774155e-42,  /* A0_lo */
   -1.8561466958242180849e-29,  /* P0  */
   -8.9096467590809520354e-30,  /* P1  */
   -1.1799786632825643786e-30,  /* P2  */
    2.7229194147660891758e+05,  /* Q0  */
    2.2915039815599177382e+05,  /* Q1  */
    6.6304470354231554666e+04,  /* Q2  */
    6.6174033980071471888e+03,  /* Q3  */
    1.6239932001189923477e-34,  /* A0_hi = exp(2.5^2)*erfc(2.5) */
   -4.4067977743414827847e-42,  /* A0_lo */
   -2.7305811796564657084e-29,  /* P0  */
   -1.2658139626293537040e-29,  /* P1  */
   -1.5992161983768154679e-30,  /* P2  */
    4.7674828670048585627e+05,  /* Q0  */
    3.8091947139688843163e+05,  /* Q1  */
    1.0438214435271381808e+05,  /* Q2  */
    9.8360417594086993631e+03,  /* Q3  */
    1.4919184889925647194e-34,  /* A0_hi = exp(2.750^2)*erfc(2.750) */
    3.2274084303016081741e-42,  /* A0_lo */
   -3.9887084676085848206e-29,  /* P0  */
   -1.7841620473027186183e-29,  /* P1  */
   -2.1529498666768653413e-30,  /* P2  */
    8.1875917748023034073e+05,  /* Q0  */
    6.2205481329162593465e+05,  /* Q1  */
    1.6172050946283590747e+05,  /* Q2  */
    1.4418782184166813749e+04,  /* Q3  */
    1.3789747188370294254e-34,  /* A0_hi = exp(3.0^2)*erfc(3.0) */
   -1.0276927247262722582e-42,  /* A0_lo */
   -5.7805981276753849067e-29,  /* P0  */
   -2.4936973440480267525e-29,  /* P1  */
   -2.8774627233546679003e-30,  /* P2  */
    1.3800503002276178449e+06,  /* Q0  */
    9.9851051611682039220e+05,  /* Q1  */
    2.4670726738722898881e+05,  /* Q2  */
    2.0854131065204273909e+04,  /* Q3  */
    1.2814008817016061330e-34,  /* A0_hi = exp(3.25^2)*erfc(3.25) */
    3.1679596090053173176e-42,  /* A0_lo */
   -8.3067949943816770900e-29,  /* P0  */
   -3.4552683810189397348e-29,  /* P1  */
   -3.8167834082366720962e-30,  /* P2  */
    2.2845281631074324250e+06,  /* Q0  */
    1.5764511756029620301e+06,  /* Q1  */
    3.7078953854475927074e+05,  /* Q2  */
    2.9772871826261114620e+04,  /* Q3  */
    1.1963388273571177607e-34,  /* A0_hi = exp(3.5^2)*erfc(3.5) */
   -2.1315004355491019907e-42,  /* A0_lo */
   -1.1832298089264295302e-28,  /* P0  */
   -4.7457179881409191962e-29,  /* P1  */
   -5.0238615712675037787e-30,  /* P2  */
    3.7168129805968375877e+06,  /* Q0  */
    2.4496518706477717496e+06,  /* Q1  */
    5.4937383079577854369e+05,  /* Q2  */
    4.1979878901512194716e+04,  /* Q3  */
    1.1215824375971089647e-34,  /* A0_hi = exp(3.75^2)*erfc(3.75) */
   -2.2402756396646664361e-42,  /* A0_lo */
   -1.6703536249346821810e-28,  /* P0  */
   -6.4611460622102107378e-29,  /* P1  */
   -6.5618434298065859425e-30,  /* P2  */
    5.9475193467168556526e+06,  /* Q0  */
    3.7490694472471671179e+06,  /* Q1  */
    8.0292732099990407005e+05,  /* Q2  */
    5.8490853738049845560e+04,  /* Q3  */
    1.0554054346825499052e-34,  /* A0_hi = exp(4.0^2)*erfc(4.0) */
   -3.4628860753222452061e-43,  /* A0_lo */
   -2.5202102031254259858e-28,  /* P0  */
   -9.4237732997270086475e-29,  /* P1  */
   -9.2093958799170116157e-30,  /* P2  */
    1.0102117635239103809e+07,  /* Q0  */
    6.1063263350123055279e+06,  /* Q1  */
    1.2524076832686711568e+06,  /* Q2  */
    8.7243912552778478130e+04,  /* Q3  */
    9.4358860085924336080e-35,  /* A0_hi = exp(4.500^2)*erfc(4.500) */
    8.2743601177384110231e-43,  /* A0_lo */
   -4.4318303378005147980e-28,  /* P0  */
   -1.5411247661736991223e-28,  /* P1  */
   -1.3902734797033603468e-29,  /* P2  */
    2.2112778547095894814e+07,  /* Q0  */
    1.2290496355886805803e+07,  /* Q1  */
    2.3121040104049840011e+06,  /* Q2  */
    1.4732268264340804308e+05,  /* Q3  */
    8.5283750971932272922e-35,  /* A0_hi = exp(5.0^2)*erfc(5.0) */
   -2.5486909237632481588e-43,  /* A0_lo */
   -8.1640614032930039888e-28,  /* P0  */
   -2.6519598149843996416e-28,  /* P1  */
   -2.2219608948868409527e-29,  /* P2  */
    4.9677316990083828568e+07,  /* Q0  */
    2.5546337595926720649e+07,  /* Q1  */
    4.4375635725916130468e+06,  /* Q2  */
    2.6051986362367705442e+05,  /* Q3  */
    7.7778466349827891785e-35,  /* A0_hi = exp(5.5^2)*erfc(5.5) */
   -2.4828841960259489792e-42,  /* A0_lo */
   -1.4554925579126264840e-27,  /* P0  */
   -4.4275287891132960141e-28,  /* P1  */
   -3.4581992310363651176e-29,  /* P2  */
    1.0617377586954347789e+08,  /* Q0  */
    5.0740236456234529614e+07,  /* Q1  */
    8.1773224203491052613e+06,  /* Q2  */
    4.4460280407726357225e+05,  /* Q3  */
    7.1472467211769227754e-35,  /* A0_hi = exp(6.000^2)*erfc(6.000) */
    8.1404255201221482261e-43,  /* A0_lo */
   -2.5165803467681650802e-27,  /* P0  */
   -7.1875918130579879043e-28,  /* P1  */
   -5.2518482059177004192e-29,  /* P2  */
    2.1690779433353570104e+08,  /* Q0  */
    9.6725160211642012000e+07,  /* Q1  */
    1.4525200431739835069e+07,  /* Q2  */
    7.3478693610256607644e+05   /* Q3  */
};
